      PROGRAM arithmetic_operations

          IMPLICIT NONE

          INTEGER,PARAMETER :: maximum_filename_length = 512

          REAL,   DIMENSION(:),ALLOCATABLE ::  &
     &        rdst, rsrc1, rsrc2, rsrc3, rsrc4
          INTEGER,DIMENSION(:),ALLOCATABLE ::  &
     &        idst, isrc1, isrc2, isrc3, isrc4
          INTEGER,DIMENSION(:),ALLOCATABLE :: permute

          CHARACTER (LEN=maximum_filename_length) :: output_filename

          REAL    :: dot, lot, rsum
          REAL    :: add_real_time, add_int_time
          REAL    :: sum_real_time, sum_int_time
          REAL    :: sub_real_time, sub_int_time
          REAL    :: mul_real_time, mul_int_time
          REAL    :: mad_real_time, mad_int_time
          REAL    :: mam_real_time, mam_int_time
          REAL    :: div_real_time, div_int_time
          REAL    :: pow_real_time, mod_int_time
          REAL    :: sqrt_real_time, cos_real_time
          REAL    :: exp_real_time, log_real_time
          REAL    :: euc_real_time, dot_real_time
          REAL    :: lot8_real_time, lot10_real_time
          REAL    :: lot12_real_time, lot16_real_time
          REAL    :: lot20_real_time, lot24_real_time
          REAL    :: i2r_time, r2i_time
          REAL    :: add_real_mflops, add_int_mflops
          REAL    :: sum_real_mflops, sum_int_mflops
          REAL    :: sub_real_mflops, sub_int_mflops
          REAL    :: mul_real_mflops, mul_int_mflops
          REAL    :: mad_real_mflops, mad_int_mflops
          REAL    :: mam_real_mflops, mam_int_mflops
          REAL    :: div_real_mflops, div_int_mflops
          REAL    :: pow_real_mflops, mod_int_mflops
          REAL    :: sqrt_real_mflops, cos_real_mflops
          REAL    :: exp_real_mflops, log_real_mflops
          REAL    :: euc_real_mflops, dot_real_mflops
          REAL    :: lot8_real_mflops, lot10_real_mflops
          REAL    :: lot12_real_mflops, lot16_real_mflops
          REAL    :: lot20_real_mflops, lot24_real_mflops
          REAL    :: i2r_mflops, r2i_mflops
          REAL    :: add_real_permuted_time, add_int_permuted_time
          REAL    :: sum_real_permuted_time, sum_int_permuted_time
          REAL    :: sub_real_permuted_time, sub_int_permuted_time
          REAL    :: mul_real_permuted_time, mul_int_permuted_time
          REAL    :: mad_real_permuted_time, mad_int_permuted_time
          REAL    :: mam_real_permuted_time, mam_int_permuted_time
          REAL    :: div_real_permuted_time, div_int_permuted_time
          REAL    :: pow_real_permuted_time, mod_int_permuted_time
          REAL    :: sqrt_real_permuted_time, cos_real_permuted_time
          REAL    :: exp_real_permuted_time, log_real_permuted_time
          REAL    :: euc_real_permuted_time, dot_real_permuted_time
          REAL    :: lot8_real_permuted_time,   &
     &               lot10_real_permuted_time
          REAL    :: lot12_real_permuted_time,  &
     &               lot16_real_permuted_time
          REAL    :: lot20_real_permuted_time,  &
     &               lot24_real_permuted_time
          REAL    :: i2r_permuted_time, r2i_permuted_time
          REAL    :: add_real_permuted_mflops, add_int_permuted_mflops
          REAL    :: sum_real_permuted_mflops, sum_int_permuted_mflops
          REAL    :: sub_real_permuted_mflops, sub_int_permuted_mflops
          REAL    :: mul_real_permuted_mflops, mul_int_permuted_mflops
          REAL    :: mad_real_permuted_mflops, mad_int_permuted_mflops
          REAL    :: mam_real_permuted_mflops, mam_int_permuted_mflops
          REAL    :: div_real_permuted_mflops, div_int_permuted_mflops
          REAL    :: pow_real_permuted_mflops, mod_int_permuted_mflops
          REAL    :: sqrt_real_permuted_mflops,   &
     &               cos_real_permuted_mflops
          REAL    :: exp_real_permuted_mflops,    &
     &               log_real_permuted_mflops
          REAL    :: euc_real_permuted_mflops,    &
     &               dot_real_permuted_mflops
          REAL    :: lot8_real_permuted_mflops,   &
     &               lot10_real_permuted_mflops
          REAL    :: lot12_real_permuted_mflops,  &
     &               lot16_real_permuted_mflops
          REAL    :: lot20_real_permuted_mflops,  &
     &               lot24_real_permuted_mflops
          REAL    :: i2r_permuted_mflops, r2i_permuted_mflops
          INTEGER :: isum
          INTEGER :: length
          INTEGER :: memory_status

          READ *, length
          READ *, output_filename

          ALLOCATE(rdst (length),   STAT=memory_status)
          ALLOCATE(rsrc1(length),   STAT=memory_status)
          ALLOCATE(rsrc2(length),   STAT=memory_status)
          ALLOCATE(rsrc3(length),   STAT=memory_status)
          ALLOCATE(rsrc4(length),   STAT=memory_status)
          ALLOCATE(idst (length),   STAT=memory_status)
          ALLOCATE(isrc1(length),   STAT=memory_status)
          ALLOCATE(isrc2(length),   STAT=memory_status)
          ALLOCATE(isrc3(length),   STAT=memory_status)
          ALLOCATE(isrc4(length),   STAT=memory_status)
          ALLOCATE(permute(length), STAT=memory_status)

          CALL set_permutation(permute, length)

          CALL initialize_source_arrays(rsrc1, rsrc2, rsrc3, rsrc4,  &
     &                                  isrc1, isrc2, isrc3, isrc4,  &
     &                                  length)

          OPEN (UNIT=9, FILE=output_filename, STATUS="unknown")

          WRITE (9,"(A,A)")  &
     &"   SIZE             TYPE    op           TIME    MFLOPS   RATIO"

          CALL time_of_add_real_arrays(rdst, rsrc1, rsrc2, length,  &
     &             add_real_time, add_real_mflops)
          CALL time_of_add_int_arrays (idst, isrc1, isrc2, length,  &
     &             add_int_time, add_int_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    add:   ",  &
     &        add_real_time, add_real_mflops
          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          INTEGER add:   ",  &
     &        add_int_time, add_int_mflops

          CALL time_of_sum_real_arrays(rsum, rsrc3, length,  &
     &             sum_real_time, sum_real_mflops)
          CALL time_of_sum_int_arrays (isum, isrc3, length,  &
     &             sum_int_time, sum_int_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    sum:   ",  &
     &        sum_real_time, sum_real_mflops
          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          INTEGER sum:   ",  &
     &        sum_int_time, sum_int_mflops

          CALL time_of_sub_real_arrays(rdst, rsrc2, rsrc4, length,  &
     &             sub_real_time, sub_real_mflops)
          CALL time_of_sub_int_arrays (idst, isrc2, isrc4, length,  &
     &             sub_int_time, sub_int_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    sub:   ",  &
     &        sub_real_time, sub_real_mflops
          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          INTEGER sub:   ",  &
     &        sub_int_time, sub_int_mflops

          CALL time_of_mul_real_arrays(rdst, rsrc1, rsrc3, length,  &
     &             mul_real_time, mul_real_mflops)
          CALL time_of_mul_int_arrays (idst, isrc1, isrc3, length,  &
     &             mul_int_time, mul_int_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    mul:   ",  &
     &        mul_real_time, mul_real_mflops
          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          INTEGER mul:   ",  &
     &        mul_int_time, mul_int_mflops

          CALL time_of_mam_real_arrays(                       &
     &             rdst, rsrc1, rsrc2, rsrc3, rsrc4, length,  &
     &             mam_real_time, mam_real_mflops)
          CALL time_of_mam_int_arrays (                       &
     &             idst, isrc1, isrc2, isrc3, isrc4, length,  &
     &             mam_int_time, mam_int_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    mam:   ",  &
     &        mam_real_time, mam_real_mflops
          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          INTEGER mam:   ",  &
     &        mam_int_time, mam_int_mflops

          CALL time_of_mad_real_arrays(rdst, rsrc2, rsrc4, length,  &
     &             mad_real_time, mad_real_mflops)
          CALL time_of_mad_int_arrays (idst, isrc2, isrc4, length,  &
     &             mad_int_time, mad_int_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    mad:   ",  &
     &        mad_real_time, mad_real_mflops
          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          INTEGER mad:   ",  &
     &        mad_int_time, mad_int_mflops

          CALL time_of_div_real_arrays(rdst, rsrc3, rsrc1, length,  &
     &             div_real_time, div_real_mflops)
          CALL time_of_div_int_arrays (idst, isrc3, isrc1, length,  &
     &             div_int_time, div_int_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")  &
     &        length, "          REAL    div:   ",  &
     &        div_real_time, div_real_mflops
          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          INTEGER div:   ",  &
     &        div_int_time, div_int_mflops

          CALL time_of_pow_real_arrays(rdst, rsrc2, rsrc4, length,  &
     &             pow_real_time, pow_real_mflops)
          CALL time_of_mod_int_arrays (idst, isrc2, isrc4, length,  &
     &             mod_int_time, mod_int_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    pow:   ",  &
     &        pow_real_time, pow_real_mflops
          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          INTEGER mod:   ",  &
     &        mod_int_time, mod_int_mflops

          CALL time_of_sqrt_real_arrays(rdst, rsrc3, length,  &
     &             sqrt_real_time, sqrt_real_mflops)
          CALL time_of_cos_real_arrays(rdst, rsrc4, length,   &
     &             cos_real_time, cos_real_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    sqrt:  ",  &
     &        sqrt_real_time, sqrt_real_mflops
          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    cos:   ",  &
     &        cos_real_time, cos_real_mflops

          CALL time_of_exp_real_arrays(rdst, rsrc3, length,  &
     &             exp_real_time, exp_real_mflops)
          CALL time_of_log_real_arrays(rdst, rsrc2, length,  &
     &             log_real_time, log_real_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    exp:   ",  &
     &        exp_real_time, exp_real_mflops
          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    log:   ",  &
     &        log_real_time, log_real_mflops

          CALL time_of_dot_real_arrays(dot, rsrc1, rsrc3,  &
     &             length, dot_real_time, dot_real_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    dot:   ",  &
     &        dot_real_time, dot_real_mflops

          CALL time_of_euc_real_arrays(               &
     &             rdst, rsrc1, rsrc2, rsrc3, rsrc4,  &
     &             length, euc_real_time, euc_real_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    euc:   ",  &
     &        euc_real_time, euc_real_mflops

          CALL time_of_lot8_real_arrays(              &
     &             lot, rsrc1, rsrc2, rsrc3, rsrc4,   &
     &             length, lot8_real_time, lot8_real_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    lot8:  ",  &
     &        lot8_real_time, lot8_real_mflops

          CALL time_of_lot10_real_arrays(             &
     &             lot, rsrc1, rsrc2, rsrc3, rsrc4,   &
     &             length, lot10_real_time, lot10_real_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    lot10: ",  &
     &        lot10_real_time, lot10_real_mflops

          CALL time_of_lot12_real_arrays(             &
     &             lot, rsrc1, rsrc2, rsrc3, rsrc4,   &
     &             length, lot12_real_time, lot12_real_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    lot12: ",  &
     &        lot12_real_time, lot12_real_mflops

          CALL time_of_lot16_real_arrays(             &
     &             lot, rsrc1, rsrc2, rsrc3, rsrc4,   &
     &             length, lot16_real_time, lot16_real_mflops)
          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    lot16: ",  &
     &        lot16_real_time, lot16_real_mflops

          CALL time_of_lot20_real_arrays(             &
     &             lot, rsrc1, rsrc2, rsrc3, rsrc4,   &
     &             length, lot20_real_time, lot20_real_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    lot20: ",  &
     &        lot20_real_time, lot20_real_mflops

          CALL time_of_lot24_real_arrays(             &
     &             lot, rsrc1, rsrc2, rsrc3, rsrc4,   &
     &             length, lot24_real_time, lot24_real_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")               &
     &        length, "          REAL    lot24: ",  &
     &        lot24_real_time, lot24_real_mflops

          CALL time_of_i2r_arrays(rdst, isrc4, length,  &
     &             i2r_time, i2r_mflops)
          CALL time_of_r2i_arrays(idst, rsrc4, length,  &
     &             r2i_time, r2i_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2)")                 &
     &        length, "                    i2r: ",  &
     &        i2r_time, i2r_mflops
          WRITE (9,"(I10,A,F10.2,F10.2)")                 &
     &        length, "                    r2i: ",  &
     &        r2i_time, r2i_mflops

          CALL time_of_add_real_arrays_perm(             &
     &             rdst, rsrc1, rsrc2, permute, length,  &
     &             add_real_permuted_time, add_real_permuted_mflops)
          CALL time_of_add_int_arrays_perm (             &
     &             idst, isrc1, isrc2, permute, length,  &
     &             add_int_permuted_time, add_int_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted REAL    add:   ",               &
     &        add_real_permuted_time, add_real_permuted_mflops,  &
     &        add_real_mflops / add_real_permuted_mflops
          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted INTEGER add:   ",               &
     &        add_int_permuted_time, add_int_permuted_mflops,    &
     &        add_int_mflops / add_int_permuted_mflops

          CALL time_of_sum_real_arrays_perm(      &
     &             rsum, rsrc3, permute, length,  &
     &             sum_real_permuted_time, sum_real_permuted_mflops)
          CALL time_of_sum_int_arrays_perm (      &
     &             isum, isrc3, permute, length,  &
     &             sum_int_permuted_time, sum_int_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted REAL    sum:   ",               &
     &        sum_real_permuted_time, sum_real_permuted_mflops,  &
     &        sum_real_mflops / sum_real_permuted_mflops
          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted INTEGER sum:   ",               &
     &        sum_int_permuted_time, sum_int_permuted_mflops,    &
     &        sum_int_mflops / sum_int_permuted_mflops

          CALL time_of_sub_real_arrays_perm(             &
     &             rdst, rsrc2, rsrc4, permute, length,  &
     &             sub_real_permuted_time, sub_real_permuted_mflops)
          CALL time_of_sub_int_arrays_perm (             &
     &             idst, isrc2, isrc4, permute, length,  &
     &             sub_int_permuted_time, sub_int_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted REAL    sub:   ",               &
     &        sub_real_permuted_time, sub_real_permuted_mflops,  &
     &        sub_real_mflops / sub_real_permuted_mflops
          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted INTEGER sub:   ",               &
     &        sub_int_permuted_time, sub_int_permuted_mflops,    &
     &        sub_int_mflops / sub_int_permuted_mflops

          CALL time_of_mul_real_arrays_perm(             &
     &             rdst, rsrc1, rsrc3, permute, length,  &
     &             mul_real_permuted_time, mul_real_permuted_mflops)
          CALL time_of_mul_int_arrays_perm (             &
     &             idst, isrc1, isrc3, permute, length,  &
     &             mul_int_permuted_time, mul_int_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted REAL    mul:   ",               &
     &        mul_real_permuted_time, mul_real_permuted_mflops,  &
     &        mul_real_mflops / mul_real_permuted_mflops
          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted INTEGER mul:   ",               &
     &        mul_int_permuted_time, mul_int_permuted_mflops,    &
     &        mul_int_mflops / mul_int_permuted_mflops

          CALL time_of_mad_real_arrays_perm(             &
     &             rdst, rsrc2, rsrc4, permute, length,  &
     &             mad_real_permuted_time, mad_real_permuted_mflops)
          CALL time_of_mad_int_arrays_perm (             &
     &             idst, isrc2, isrc4, permute, length,  &
     &             mad_int_permuted_time, mad_int_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted REAL    mad:   ",               &
     &        mad_real_permuted_time, mad_real_permuted_mflops,  &
     &        mad_real_mflops / mad_real_permuted_mflops
          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted INTEGER mad:   ",               &
     &        mad_int_permuted_time, mad_int_permuted_mflops,    &
     &        mad_int_mflops / mad_int_permuted_mflops

          CALL time_of_mam_real_arrays_perm(          &
     &             rdst, rsrc1, rsrc2, rsrc3, rsrc4,  &
     &             permute, length,                   &
     &             mam_real_permuted_time, mam_real_permuted_mflops)
          CALL time_of_mam_int_arrays_perm (          &
     &             idst, isrc1, isrc2, isrc3, isrc4,  &
     &             permute, length,                   &
     &             mam_int_permuted_time, mam_int_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                      &
     &        length, " permuted REAL    mam:   ",                &
     &        mam_real_permuted_time, mam_real_permuted_mflops,   &
     &        mam_real_mflops / mam_real_permuted_mflops
          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                      &
     &        length, " permuted INTEGER mam:   ",                &
     &        mam_int_permuted_time, mam_int_permuted_mflops,     &
     &        mam_int_mflops / mam_int_permuted_mflops

          CALL time_of_div_real_arrays_perm(             &
     &             rdst, rsrc4, rsrc2, permute, length,  &
     &             div_real_permuted_time, div_real_permuted_mflops)
          CALL time_of_div_int_arrays_perm (             &
     &             idst, isrc4, isrc2, permute, length,  &
     &             div_int_permuted_time, div_int_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted REAL    div:   ",               &
     &        div_real_permuted_time, div_real_permuted_mflops,  &
     &        div_real_mflops / div_real_permuted_mflops
          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted INTEGER div:   ",               &
     &        div_int_permuted_time, div_int_permuted_mflops,    &
     &        div_int_mflops / div_int_permuted_mflops

          CALL time_of_pow_real_arrays_perm(             &
     &             rdst, rsrc1, rsrc3, permute, length,  &
     &             pow_real_permuted_time, pow_real_permuted_mflops)
          CALL time_of_mod_int_arrays_perm (             &
     &             idst, isrc3, isrc1, permute, length,  &
     &             mod_int_permuted_time, mod_int_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted REAL    pow:   ",               &
     &        pow_real_permuted_time, pow_real_permuted_mflops,  &
     &        pow_real_mflops / pow_real_permuted_mflops
          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted INTEGER mod:   ",               &
     &        mod_int_permuted_time, mod_int_permuted_mflops,    &
     &        mod_int_mflops / mod_int_permuted_mflops

          CALL time_of_sqrt_real_arrays_perm(     &
     &             rdst, rsrc4, permute, length,  &
     &             sqrt_real_permuted_time, sqrt_real_permuted_mflops)
          CALL time_of_cos_real_arrays_perm(      &
     &             rdst, rsrc3, permute, length,  &
     &             cos_real_permuted_time, cos_real_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                       &
     &        length, " permuted REAL    sqrt:  ",                 &
     &        sqrt_real_permuted_time, sqrt_real_permuted_mflops,  &
     &        sqrt_real_mflops / sqrt_real_permuted_mflops
          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                       &
     &        length, " permuted REAL    cos:   ",                 &
     &        cos_real_permuted_time, cos_real_permuted_mflops,    &
     &        cos_real_mflops / cos_real_permuted_mflops

          CALL time_of_exp_real_arrays_perm(      &
     &             rdst, rsrc4, permute, length,  &
     &             exp_real_permuted_time, exp_real_permuted_mflops)
          CALL time_of_log_real_arrays_perm(      &
     &             rdst, rsrc2, permute, length,  &
     &             log_real_permuted_time, log_real_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted REAL    exp:   ",               &
     &        exp_real_permuted_time, exp_real_permuted_mflops,  &
     &        exp_real_mflops / exp_real_permuted_mflops
          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted REAL    log:   ",               &
     &        log_real_permuted_time, log_real_permuted_mflops,  &
     &        log_real_mflops / log_real_permuted_mflops

          CALL time_of_dot_real_arrays_perm(            &
     &             dot, rsrc1, rsrc3, permute, length,  &
     &             dot_real_permuted_time, dot_real_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")                     &
     &        length, " permuted REAL    dot:   ",               &
     &        dot_real_permuted_time, dot_real_permuted_mflops,  &
     &        dot_real_mflops / dot_real_permuted_mflops

          CALL time_of_euc_real_arrays_perm(          &
     &             rdst, rsrc1, rsrc2, rsrc3, rsrc4,  &
     &             permute, length,                   &
     &             euc_real_permuted_time, euc_real_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")          &
     &        length, " permuted REAL    euc:   ",    &
     &        euc_real_permuted_time,                 &
     &        euc_real_permuted_mflops,               &
     &        euc_real_mflops / euc_real_permuted_mflops

          CALL time_of_lot8_real_arrays_perm(        &
     &             lot, rsrc1, rsrc2, rsrc3, rsrc4,  &
     &             permute, length,                  &
     &             lot8_real_permuted_time,          &
     &             lot8_real_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")         &
     &        length, " permuted REAL    lot8:  ",   &
     &        lot8_real_permuted_time,               &
     &        lot8_real_permuted_mflops,             &
     &        lot8_real_mflops / lot8_real_permuted_mflops

          CALL time_of_lot10_real_arrays_perm(       &
     &             lot, rsrc1, rsrc2, rsrc3, rsrc4,  &
     &             permute, length,                  &
     &             lot10_real_permuted_time,         &
     &             lot10_real_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")         &
     &        length, " permuted REAL    lot10: ",   &
     &        lot10_real_permuted_time,              &
     &        lot10_real_permuted_mflops,            &
     &        lot10_real_mflops / lot10_real_permuted_mflops

          CALL time_of_lot12_real_arrays_perm(       &
     &             lot, rsrc1, rsrc2, rsrc3, rsrc4,  &
     &             permute, length,                  &
     &             lot12_real_permuted_time,         &
     &             lot12_real_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")         &
     &        length, " permuted REAL    lot12: ",   &
     &        lot12_real_permuted_time,              &
     &        lot12_real_permuted_mflops,            &
     &        lot12_real_mflops / lot12_real_permuted_mflops

          CALL time_of_lot16_real_arrays_perm(       &
     &             lot, rsrc1, rsrc2, rsrc3, rsrc4,  &
     &             permute, length,                  &
     &             lot16_real_permuted_time,         &
     &             lot16_real_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")         &
     &        length, " permuted REAL    lot16: ",   &
     &        lot16_real_permuted_time,              &
     &        lot16_real_permuted_mflops,            &
     &        lot16_real_mflops / lot16_real_permuted_mflops

          CALL time_of_lot20_real_arrays_perm(       &
     &             lot, rsrc1, rsrc2, rsrc3, rsrc4,  &
     &             permute, length,                  &
     &             lot20_real_permuted_time,         &
     &             lot20_real_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")         &
     &        length, " permuted REAL    lot20: ",   &
     &        lot20_real_permuted_time,              &
     &        lot20_real_permuted_mflops,            &
     &        lot20_real_mflops / lot20_real_permuted_mflops

          CALL time_of_lot24_real_arrays_perm(       &
     &             lot, rsrc1, rsrc2, rsrc3, rsrc4,  &
     &             permute, length,                  &
     &             lot24_real_permuted_time,         &
     &             lot24_real_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")         &
     &        length, " permuted REAL    lot24: ",   &
     &        lot24_real_permuted_time,              &
     &        lot24_real_permuted_mflops,            &
     &        lot24_real_mflops / lot24_real_permuted_mflops

          CALL time_of_i2r_arrays_perm(                &
     &             rdst, isrc3, permute, length,       &
     &             i2r_permuted_time, i2r_permuted_mflops)
          CALL time_of_r2i_arrays_perm(                &
     &             idst, rsrc1, permute, length,       &
     &             r2i_permuted_time, r2i_permuted_mflops)

          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")           &
     &        length, " permuted           i2r: ",   &
     &        i2r_permuted_time, i2r_permuted_mflops,  &
     &        i2r_mflops / i2r_permuted_mflops
          WRITE (9,"(I10,A,F10.2,F10.2,F10.2)")           &
     &        length, " permuted           r2i: ",   &
     &        r2i_permuted_time, r2i_permuted_mflops,  &
     &        r2i_mflops / r2i_permuted_mflops

          CLOSE (UNIT=9)

          DEALLOCATE(rdst,    STAT=memory_status)
          DEALLOCATE(rsrc1,   STAT=memory_status)
          DEALLOCATE(rsrc2,   STAT=memory_status)
          DEALLOCATE(rsrc3,   STAT=memory_status)
          DEALLOCATE(rsrc4,   STAT=memory_status)
          DEALLOCATE(idst,    STAT=memory_status)
          DEALLOCATE(isrc1,   STAT=memory_status)
          DEALLOCATE(isrc2,   STAT=memory_status)
          DEALLOCATE(isrc3,   STAT=memory_status)
          DEALLOCATE(isrc4,   STAT=memory_status)
          DEALLOCATE(permute, STAT=memory_status)

      END PROGRAM arithmetic_operations

      SUBROUTINE set_permutation (permute, length)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: permute

          REAL    :: random_value
          INTEGER :: index, random_index, temporary_index

          DO index = 1, length
              permute(index) = index
          END DO !! index

          DO index = 1, length

              CALL random_number(random_value)

              random_index = FLOOR(random_value * length) + 1

              IF (random_index /= index) THEN

                  temporary_index       = permute(index)
                  permute(index)        = permute(random_index)
                  permute(random_index) = temporary_index

              END IF !! (random_index /= index)

          END DO !! index

      END SUBROUTINE set_permutation

      SUBROUTINE initialize_source_arrays (      &
     &               rsrc1, rsrc2, rsrc3, rsrc4, &
     &               isrc1, isrc2, isrc3, isrc4, length)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,   DIMENSION(length),INTENT(OUT) ::  &
     &        rsrc1, rsrc2, rsrc3, rsrc4
          INTEGER,DIMENSION(length),INTENT(OUT) ::  &
     &        isrc1, isrc2, isrc3, isrc4

          INTEGER :: index

          DO index = 1, length

              rsrc1(index) =  index * 0.375
              rsrc2(index) =  index * 1.375
              rsrc3(index) = (index - 1.0) / length
              rsrc4(index) = rsrc3(index) * rsrc3(index)
              isrc1(index) =  index * 2 + 1
              isrc2(index) =  index * 3 + 2
              isrc3(index) = -index * 7
              isrc4(index) =  index * 11 + 7

          END DO !! index

      END SUBROUTINE initialize_source_arrays

      SUBROUTINE time_of_add_real_arrays (     &
     &               dst, src1, src2, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT) :: dst
          REAL,DIMENSION(length),INTENT(IN)  :: src1, src2
          REAL,INTENT(OUT) :: time_of_operation
          REAL,INTENT(OUT) :: mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = src1(index) + src2(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_add_real_arrays

      SUBROUTINE time_of_add_int_arrays (      &
     &               dst, src1, src2, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  :: src1, src2
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = src1(index) + src2(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_add_int_arrays

      SUBROUTINE time_of_sum_real_arrays (  &
     &               dst, src, length,      &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN) :: src
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          dst = 0.0
          DO index = 1, length
              dst = dst + src(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_sum_real_arrays

      SUBROUTINE time_of_sum_int_arrays (  &
     &               dst, src, length,     &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN) :: src
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          dst = 0
          DO index = 1, length
              dst = dst + src(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_sum_int_arrays

      SUBROUTINE time_of_sub_real_arrays (     &
     &               dst, src1, src2, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT) :: dst
          REAL,DIMENSION(length),INTENT(IN)  :: src1, src2
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = src1(index) - src2(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_sub_real_arrays

      SUBROUTINE time_of_sub_int_arrays (      &
     &               dst, src1, src2, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  :: src1, src2
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = src1(index) - src2(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_sub_int_arrays

      SUBROUTINE time_of_mul_real_arrays (     &
     &               dst, src1, src2, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT) :: dst
          REAL,DIMENSION(length),INTENT(IN)  :: src1, src2
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = src1(index) * src2(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mul_real_arrays

      SUBROUTINE time_of_mul_int_arrays (      &
     &               dst, src1, src2, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  :: src1, src2
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = src1(index) * src2(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mul_int_arrays

      SUBROUTINE time_of_mad_real_arrays (     &
     &               dst, src1, src2, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT) :: dst
          REAL,DIMENSION(length),INTENT(IN)  :: src1, src2
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = src1(index) + 5.0 * src2(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        2.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mad_real_arrays

      SUBROUTINE time_of_mad_int_arrays (      &
     &               dst, src1, src2, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  :: src1, src2
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = src1(index) + 5 * src2(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        2.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mad_int_arrays

      SUBROUTINE time_of_mam_real_arrays (                 &
     &               dst, src1, src2, src3, src4, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT) :: dst
          REAL,DIMENSION(length),INTENT(IN)  ::  &
     &        src1, src2, src3, src4
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) =                     &
     &            src1(index) * src2(index) +  &
     &            src3(index) * src4(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        3.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mam_real_arrays

      SUBROUTINE time_of_mam_int_arrays (                  &
     &               dst, src1, src2, src3, src4, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  ::  &
     &        src1, src2, src3, src4
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) =                     &
     &            src1(index) * src2(index) +  &
     &            src3(index) * src4(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        3.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mam_int_arrays

      SUBROUTINE time_of_div_real_arrays (     &
     &               dst, src1, src2, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT) :: dst
          REAL,DIMENSION(length),INTENT(IN)  :: src1, src2
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = src1(index) / src2(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_div_real_arrays

      SUBROUTINE time_of_div_int_arrays (      &
     &               dst, src1, src2, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  :: src1, src2
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = src1(index) / src2(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_div_int_arrays

      SUBROUTINE time_of_pow_real_arrays (     &
     &               dst, src1, src2, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    :: src1, src2
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = src1(index) ** src2(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_pow_real_arrays

      SUBROUTINE time_of_mod_int_arrays (      &
     &               dst, src1, src2, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  :: src1, src2
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = MOD(src1(index), src2(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mod_int_arrays

      SUBROUTINE time_of_sqrt_real_arrays (  &
     &               dst, src, length,       &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT) :: dst
          REAL,DIMENSION(length),INTENT(IN)  :: src
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = SQRT(src(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_sqrt_real_arrays

      SUBROUTINE time_of_cos_real_arrays (  &
     &               dst, src, length,      &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT) :: dst
          REAL,DIMENSION(length),INTENT(IN)  :: src
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = COS(src(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_cos_real_arrays

      SUBROUTINE time_of_exp_real_arrays (  &
     &               dst, src, length,      &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT) :: dst
          REAL,DIMENSION(length),INTENT(IN)  :: src
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = EXP(src(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_exp_real_arrays

      SUBROUTINE time_of_log_real_arrays (  &
     &               dst, src, length,      &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT) :: dst
          REAL,DIMENSION(length),INTENT(IN)  :: src
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(index) = LOG(src(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_log_real_arrays

      SUBROUTINE time_of_euc_real_arrays (                 &
     &               dst, src1, src2, src3, src4, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT) :: dst
          REAL,DIMENSION(length),INTENT(IN)  :: src1, src2, src3, src4
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: diff12, diff34
          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              diff12 = src1(index) - src2(index)
              diff34 = src3(index) - src4(index)
              dst(index) = SQRT(diff12 * diff12 + diff34 * diff34)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        6.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_euc_real_arrays

      SUBROUTINE time_of_dot_real_arrays (     &
     &               dot, src1, src2, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: dot
          REAL,DIMENSION(length),INTENT(IN) :: src1, src2
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          dot = 0.0
          DO index = 1, length
              dot = dot + src1(index) * src2(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        2.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_dot_real_arrays

      SUBROUTINE time_of_lot8_real_arrays (                &
     &               lot, src1, src2, src3, src4, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: lot
          REAL,DIMENSION(length),INTENT(IN) :: src1, src2, src3, src4
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          lot = 0.0
          DO index = 1, length
              lot = lot +                          &
     &              src1(index) * src2(index) +    &
     &              src3(index) * src4(index) +    &
     &              (src1(index) + src2(index)) *  &
     &              (src3(index) + src4(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        8.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_lot8_real_arrays

      SUBROUTINE time_of_lot10_real_arrays (               &
     &               lot, src1, src2, src3, src4, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: lot
          REAL,DIMENSION(length),INTENT(IN) :: src1, src2, src3, src4
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          lot = 0.0
          DO index = 1, length
              lot = lot +                          &
     &              src1(index) * src2(index) +    &
     &              src3(index) * src4(index) +    &
     &              (src1(index) + src2(index)) *  &
     &              (src3(index) + src4(index)) *  &
     &              (src1(index) - src2(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        10.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_lot10_real_arrays

      SUBROUTINE time_of_lot12_real_arrays (               &
     &               lot, src1, src2, src3, src4, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: lot
          REAL,DIMENSION(length),INTENT(IN) :: src1, src2, src3, src4
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          lot = 0.0
          DO index = 1, length
              lot = lot +                          &
     &              src1(index) * src2(index) +    &
     &              src3(index) * src4(index) +    &
     &              (src1(index) + src2(index)) *  &
     &              (src3(index) + src4(index)) *  &
     &              (src1(index) - src2(index)) *  &
     &              (src3(index) - src4(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        12.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_lot12_real_arrays

      SUBROUTINE time_of_lot16_real_arrays (               &
     &               lot, src1, src2, src3, src4, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: lot
          REAL,DIMENSION(length),INTENT(IN) :: src1, src2, src3, src4
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          lot = 0.0
          DO index = 1, length
              lot = lot +                          &
     &              src1(index) * src2(index) +    &
     &              src3(index) * src4(index) +    &
     &              (src1(index) + src2(index)) *  &
     &              (src3(index) + src4(index)) *  &
     &              (src1(index) - src2(index)) *  &
     &              (src3(index) - src4(index)) *  &
     &              (src1(index) - src3(index) +   &
     &               src2(index) - src4(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        16.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_lot16_real_arrays

      SUBROUTINE time_of_lot20_real_arrays (               &
     &               lot, src1, src2, src3, src4, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: lot
          REAL,DIMENSION(length),INTENT(IN) :: src1, src2, src3, src4
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          lot = 0.0
          DO index = 1, length
              lot = lot +                          &
     &              src1(index) * src2(index) +    &
     &              src3(index) * src4(index) +    &
     &              (src1(index) + src2(index)) *  &
     &              (src3(index) + src4(index)) *  &
     &              (src1(index) - src2(index)) *  &
     &              (src3(index) - src4(index)) *  &
     &              (src1(index) - src3(index) +   &
     &               src2(index) - src4(index)) *  &
     &              (src1(index) + src3(index) -   &
     &               src2(index) + src4(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        20.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_lot20_real_arrays

      SUBROUTINE time_of_lot24_real_arrays (               &
     &               lot, src1, src2, src3, src4, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: lot
          REAL,DIMENSION(length),INTENT(IN) :: src1, src2, src3, src4
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          lot = 0.0
          DO index = 1, length
              lot = lot +                          &
     &              src1(index) * src2(index) +    &
     &              src3(index) * src4(index) +    &
     &              (src1(index) + src2(index)) *  &
     &              (src3(index) + src4(index)) *  &
     &              (src1(index) - src2(index)) *  &
     &              (src3(index) - src4(index)) *  &
     &              (src1(index) - src3(index) +   &
     &               src2(index) - src4(index)) *  &
     &              (src1(index) + src3(index) -   &
     &               src2(index) + src4(index)) +  &
     &              (src1(index) * src3(index)) +  &
     &              (src2(index) * src4(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        24.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_lot24_real_arrays

      SUBROUTINE time_of_i2r_arrays (rdst, isrc, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,   DIMENSION(length),INTENT(OUT) :: rdst
          INTEGER,DIMENSION(length),INTENT(IN)  :: isrc
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              rdst(index) = isrc(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_i2r_arrays

      SUBROUTINE time_of_r2i_arrays (idst, rsrc, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: idst
          REAL,   DIMENSION(length),INTENT(IN)  :: rsrc
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              idst(index) = rsrc(index)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_r2i_arrays

      SUBROUTINE time_of_add_real_arrays_perm (         &
     &               dst, src1, src2, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    :: src1, src2
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =  &
     &            src1(permute(index)) + src2(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_add_real_arrays_perm

      SUBROUTINE time_of_add_int_arrays_perm (          &
     &               dst, src1, src2, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  :: src1, src2
          INTEGER,DIMENSION(length),INTENT(IN)  :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =  &
     &            src1(permute(index)) + src2(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_add_int_arrays_perm

      SUBROUTINE time_of_sum_real_arrays_perm (  &
     &               dst, src, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    :: src
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          dst = 0.0
          DO index = 1, length
              dst = dst + src(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_sum_real_arrays_perm

      SUBROUTINE time_of_sum_int_arrays_perm (   &
     &               dst, src, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  :: src
          INTEGER,DIMENSION(length),INTENT(IN)  :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          dst = 0
          DO index = 1, length
              dst = dst + src(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_sum_int_arrays_perm

      SUBROUTINE time_of_sub_real_arrays_perm (         &
     &               dst, src1, src2, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    :: src1, src2
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =  &
     &            src1(permute(index)) - src2(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_sub_real_arrays_perm

      SUBROUTINE time_of_sub_int_arrays_perm (          &
     &               dst, src1, src2, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  :: src1, src2
          INTEGER,DIMENSION(length),INTENT(IN)  :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =  &
       &          src1(permute(index)) - src2(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_sub_int_arrays_perm

      SUBROUTINE time_of_mul_real_arrays_perm (         &
     &               dst, src1, src2, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    :: src1, src2
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =  &
     &            src1(permute(index)) * src2(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mul_real_arrays_perm

      SUBROUTINE time_of_mul_int_arrays_perm (          &
     &               dst, src1, src2, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  :: src1, src2
          INTEGER,DIMENSION(length),INTENT(IN)  :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =  &
     &            src1(permute(index)) * src2(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mul_int_arrays_perm

      SUBROUTINE time_of_mad_real_arrays_perm (         &
     &               dst, src1, src2, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    :: src1, src2
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =  &
     &            src1(permute(index)) + 5.0 * src2(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        2.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mad_real_arrays_perm

      SUBROUTINE time_of_mad_int_arrays_perm (          &
     &               dst, src1, src2, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  :: src1, src2
          INTEGER,DIMENSION(length),INTENT(IN)  :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =  &
     &            src1(permute(index)) + 5 * src2(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        2.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mad_int_arrays_perm

      SUBROUTINE time_of_mam_real_arrays_perm (                     &
     &               dst, src1, src2, src3, src4, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    ::  &
     &        src1, src2, src3, src4
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =                              &
     &            src1(permute(index)) * src2(permute(index)) +  &
     &            src3(permute(index)) * src4(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        3.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mam_real_arrays_perm

      SUBROUTINE time_of_mam_int_arrays_perm (                      &
     &               dst, src1, src2, src3, src4, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  ::  &
     &        src1, src2, src3, src4
          INTEGER,DIMENSION(length),INTENT(IN)  :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =                              &
     &            src1(permute(index)) * src2(permute(index)) +  &
     &            src3(permute(index)) * src4(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        3.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mam_int_arrays_perm

      SUBROUTINE time_of_div_real_arrays_perm (         &
     &               dst, src1, src2, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    :: src1, src2
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =  &
     &            src1(permute(index)) / src2(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_div_real_arrays_perm

      SUBROUTINE time_of_div_int_arrays_perm (          &
     &               dst, src1, src2, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  :: src1, src2
          INTEGER,DIMENSION(length),INTENT(IN)  :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =  &
     &            src1(permute(index)) / src2(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_div_int_arrays_perm

      SUBROUTINE time_of_pow_real_arrays_perm (         &
     &               dst, src1, src2, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    :: src1, src2
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =  &
     &            src1(permute(index)) ** src2(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_pow_real_arrays_perm

      SUBROUTINE time_of_mod_int_arrays_perm (          &
     &               dst, src1, src2, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: dst
          INTEGER,DIMENSION(length),INTENT(IN)  :: src1, src2
          INTEGER,DIMENSION(length),INTENT(IN)  :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) =  &
     &            MOD(src1(permute(index)), src2(permute(index)))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_mod_int_arrays_perm

      SUBROUTINE time_of_sqrt_real_arrays_perm (  &
     &               dst, src, permute, length,   &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    :: src
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) = SQRT(src(permute(index)))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_sqrt_real_arrays_perm

      SUBROUTINE time_of_cos_real_arrays_perm (  &
     &               dst, src, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    :: src
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) = COS(src(permute(index)))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_cos_real_arrays_perm

      SUBROUTINE time_of_exp_real_arrays_perm (  &
     &               dst, src, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    :: src
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) = EXP(src(permute(index)))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_exp_real_arrays_perm

      SUBROUTINE time_of_log_real_arrays_perm (  &
     &               dst, src, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    :: src
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              dst(permute(index)) = LOG(src(permute(index)))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_log_real_arrays_perm

      SUBROUTINE time_of_euc_real_arrays_perm (                     &
     &               dst, src1, src2, src3, src4, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,DIMENSION(length),INTENT(OUT)   :: dst
          REAL,DIMENSION(length),INTENT(IN)    ::   &
     &        src1, src2, src3, src4
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: diff12, diff34
          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
            diff12 = src1(permute(index)) - src2(permute(index))
            diff34 = src3(permute(index)) - src4(permute(index))
            dst(permute(index)) =  &
     &          SQRT(diff12 * diff12 + diff34 * diff34)
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        6.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_euc_real_arrays_perm

      SUBROUTINE time_of_dot_real_arrays_perm (         &
     &               dot, src1, src2, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: dot
          REAL,DIMENSION(length),INTENT(IN)    :: src1, src2
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          dot = 0.0
          DO index = 1, length
              dot = dot + src1(permute(index)) * src2(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        2.0 * length / time_of_operation * 1.0E-06
      END SUBROUTINE time_of_dot_real_arrays_perm

      SUBROUTINE time_of_lot8_real_arrays_perm (                    &
     &               lot, src1, src2, src3, src4, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: lot
          REAL,DIMENSION(length),INTENT(IN)    ::  &
     &        src1, src2, src3, src4
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          lot = 0.0
          DO index = 1, length
              lot = lot +                                            &
     &              src1(permute(index)) * src2(permute(index)) +    &
     &              src3(permute(index)) * src4(permute(index)) +    &
     &              (src1(permute(index)) + src2(permute(index))) *  &
     &              (src3(permute(index)) + src4(permute(index)))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        8.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_lot8_real_arrays_perm

      SUBROUTINE time_of_lot10_real_arrays_perm (                   &
     &               lot, src1, src2, src3, src4, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: lot
          REAL,DIMENSION(length),INTENT(IN)    :: src1, src2, src3, src4
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          lot = 0.0
          DO index = 1, length
              lot = lot +                                            &
     &              src1(permute(index)) * src2(permute(index)) +    &
     &              src3(permute(index)) * src4(permute(index)) +    &
     &              (src1(permute(index)) + src2(permute(index))) *  &
     &              (src3(permute(index)) + src4(permute(index))) *  &
     &              (src1(permute(index)) - src2(permute(index)))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        10.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_lot10_real_arrays_perm

      SUBROUTINE time_of_lot12_real_arrays_perm (                   &
     &               lot, src1, src2, src3, src4, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: lot
          REAL,DIMENSION(length),INTENT(IN)    ::  &
     &        src1, src2, src3, src4
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          lot = 0.0
          DO index = 1, length
              lot = lot +                                            &
     &              src1(permute(index)) * src2(permute(index)) +    &
     &              src3(permute(index)) * src4(permute(index)) +    &
     &              (src1(permute(index)) + src2(permute(index))) *  &
     &              (src3(permute(index)) + src4(permute(index))) *  &
     &              (src1(permute(index)) - src2(permute(index))) *  &
     &              (src3(permute(index)) - src4(permute(index)))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        12.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_lot12_real_arrays_perm

      SUBROUTINE time_of_lot16_real_arrays_perm (                   &
     &               lot, src1, src2, src3, src4, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: lot
          REAL,DIMENSION(length),INTENT(IN)    ::  &
     &        src1, src2, src3, src4
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          lot = 0.0
          DO index = 1, length
              lot = lot +                                            &
     &              src1(permute(index)) * src2(permute(index)) +    &
     &              src3(permute(index)) * src4(permute(index)) +    &
     &              (src1(permute(index)) + src2(permute(index))) *  &
     &              (src3(permute(index)) + src4(permute(index))) *  &
     &              (src1(permute(index)) - src2(permute(index))) *  &
     &              (src3(permute(index)) - src4(permute(index))) *  &
     &              (src1(permute(index)) - src3(permute(index)) +   &
     &               src2(permute(index)) - src4(permute(index)))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        16.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_lot16_real_arrays_perm

      SUBROUTINE time_of_lot20_real_arrays_perm (                   &
     &               lot, src1, src2, src3, src4, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: lot
          REAL,DIMENSION(length),INTENT(IN)    ::  &
     &        src1, src2, src3, src4
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          lot = 0.0
          DO index = 1, length
              lot = lot +                                            &
     &              src1(permute(index)) * src2(permute(index)) +    &
     &              src3(permute(index)) * src4(permute(index)) +    &
     &              (src1(permute(index)) + src2(permute(index))) *  &
     &              (src3(permute(index)) + src4(permute(index))) *  &
     &              (src1(permute(index)) - src2(permute(index))) *  &
     &              (src3(permute(index)) - src4(permute(index))) *  &
     &              (src1(permute(index)) - src3(permute(index)) +   &
     &               src2(permute(index)) - src4(permute(index))) *  &
     &              (src1(permute(index)) + src3(permute(index)) -   &
     &               src2(permute(index)) + src4(permute(index)))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        20.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_lot20_real_arrays_perm

      SUBROUTINE time_of_lot24_real_arrays_perm (                   &
     &               lot, src1, src2, src3, src4, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,INTENT(OUT)   :: lot
          REAL,DIMENSION(length),INTENT(IN)    ::  &
     &        src1, src2, src3, src4
          INTEGER,DIMENSION(length),INTENT(IN) :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          lot = 0.0
          DO index = 1, length
              lot = lot +                                            &
     &              src1(permute(index)) * src2(permute(index)) +    &
     &              src3(permute(index)) * src4(permute(index)) +    &
     &              (src1(permute(index)) + src2(permute(index))) *  &
     &              (src3(permute(index)) + src4(permute(index))) *  &
     &              (src1(permute(index)) - src2(permute(index))) *  &
     &              (src3(permute(index)) - src4(permute(index))) *  &
     &              (src1(permute(index)) - src3(permute(index)) +   &
     &               src2(permute(index)) - src4(permute(index))) *  &
     &              (src1(permute(index)) + src3(permute(index)) -   &
     &               src2(permute(index)) + src4(permute(index))) +  &
     &              (src1(permute(index)) * src3(permute(index))) +  &
     &              (src2(permute(index)) * src4(permute(index)))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        24.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_lot24_real_arrays_perm

      SUBROUTINE time_of_i2r_arrays_perm (         &
     &               rdst, isrc, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          REAL,   DIMENSION(length),INTENT(OUT) :: rdst
          INTEGER,DIMENSION(length),INTENT(IN)  :: isrc
          INTEGER,DIMENSION(length),INTENT(IN)  :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              rdst(permute(index)) = isrc(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_i2r_arrays_perm

      SUBROUTINE time_of_r2i_arrays_perm (         &
     &               idst, rsrc, permute, length,  &
     &               time_of_operation, mflops_of_operation)
          IMPLICIT NONE
          INTEGER,INTENT(IN) :: length
          INTEGER,DIMENSION(length),INTENT(OUT) :: idst
          REAL,   DIMENSION(length),INTENT(IN)  :: rsrc
          INTEGER,DIMENSION(length),INTENT(IN)  :: permute
          REAL,INTENT(OUT) :: time_of_operation, mflops_of_operation

          REAL    :: start_time, end_time
          INTEGER :: index
          REAL,EXTERNAL :: mysecond

          start_time = mysecond()

          DO index = 1, length
              idst(permute(index)) = rsrc(permute(index))
          END DO !! index

          end_time = mysecond()

          time_of_operation = end_time - start_time
          mflops_of_operation =  &
     &        1.0 * length / time_of_operation * 1.0E-06

      END SUBROUTINE time_of_r2i_arrays_perm

